Index: LMDZ5/trunk/libf/dyn3dmem/integrd_loc.F
===================================================================
--- LMDZ5/trunk/libf/dyn3dmem/integrd_loc.F	(revision 1702)
+++ LMDZ5/trunk/libf/dyn3dmem/integrd_loc.F	(revision 1705)
@@ -38,5 +38,5 @@
 #include "serre.h"
 #include "iniprint.h"
-      include 'mpif.h'
+!      include 'mpif.h'
 
 c   Arguments:
Index: LMDZ5/trunk/libf/dyn3dmem/leapfrog_loc.F
===================================================================
--- LMDZ5/trunk/libf/dyn3dmem/leapfrog_loc.F	(revision 1702)
+++ LMDZ5/trunk/libf/dyn3dmem/leapfrog_loc.F	(revision 1705)
@@ -78,5 +78,5 @@
 #include "iniprint.h"
 #include "academic.h"
-      include "mpif.h"
+!      include "mpif.h"
       
       INTEGER         longcles
@@ -237,5 +237,6 @@
 
 c Allocate variables depending on dynamic variable nqtot
-!c$OMP MASTER
+!$OMP MASTER
+      if (firstcall) then
 !      
 !      ALLOCATE(p(ijb_u:ije_u,llmp1))
@@ -266,6 +267,7 @@
 !      ALLOCATE(vcont(ijb_v:ije_v,llm),ucont(ijb_u:ije_u,llm))
 !      ALLOCATE(vnat(ijb_v:ije_v,llm),unat(ijb_u:ije_u,llm))
-!c$OMP END MASTER      
-!c$OMP BARRIER
+      endif
+!$OMP END MASTER      
+!$OMP BARRIER
 
 !                CALL dynredem1_loc("restart.nc",0.0,
Index: LMDZ5/trunk/libf/dyn3dmem/mod_filtreg_p.F
===================================================================
--- LMDZ5/trunk/libf/dyn3dmem/mod_filtreg_p.F	(revision 1702)
+++ LMDZ5/trunk/libf/dyn3dmem/mod_filtreg_p.F	(revision 1705)
@@ -210,24 +210,39 @@
                IF( ifiltre.EQ.-2 )   THEN
                   DO j = jdfil,jffil
-                     CALL DGEMM("N", "N", iim, nbniv_loc, iim, 1.0, 
+#ifdef BLAS
+                     CALL SGEMM("N", "N", iim, nbniv_loc, iim, 1.0, 
      &                    matrinvn(1,1,j), iim, 
      &                    champ_loc(1,j,1), iip1*(jje-jjb+1), 0.0,
      &                    champ_fft(1,j,1), iip1*(jje-jjb+1))
+#else
+                     champ_fft(:,j,:)=
+     &                    matmul(matrinvn(:,:,j),champ_loc(:iim,j,:))
+#endif
                   ENDDO
                   
                ELSE IF ( griscal )     THEN
                   DO j = jdfil,jffil
-                     CALL DGEMM("N", "N", iim, nbniv_loc, iim, 1.0, 
+#ifdef BLAS
+                     CALL SGEMM("N", "N", iim, nbniv_loc, iim, 1.0, 
      &                    matriceun(1,1,j), iim, 
      &                    champ_loc(1,j,1), iip1*(jje-jjb+1), 0.0,
      &                    champ_fft(1,j,1), iip1*(jje-jjb+1))
+#else
+                     champ_fft(:,j,:)=
+     &                    matmul(matriceun(:,:,j),champ_loc(:iim,j,:))
+#endif
                   ENDDO
                   
                ELSE 
                   DO j = jdfil,jffil
-                     CALL DGEMM("N", "N", iim, nbniv_loc, iim, 1.0, 
+#ifdef BLAS
+                     CALL SGEMM("N", "N", iim, nbniv_loc, iim, 1.0, 
      &                    matricevn(1,1,j), iim, 
      &                    champ_loc(1,j,1), iip1*(jje-jjb+1), 0.0, 
      &                    champ_fft(1,j,1), iip1*(jje-jjb+1))
+#else
+                     champ_fft(:,j,:)=
+     &                    matmul(matricevn(:,:,j),champ_loc(:iim,j,:))
+#endif
                   ENDDO
                   
@@ -238,8 +253,14 @@
                IF( ifiltre.EQ.-2 )   THEN
                   DO j = jdfil,jffil
-                     CALL DGEMM("N", "N", iim, nbniv_loc, iim, 1.0, 
+#ifdef BLAS
+                     CALL SGEMM("N", "N", iim, nbniv_loc, iim, 1.0, 
      &                    matrinvs(1,1,j-jfiltsu+1), iim, 
      &                    champ_loc(1,j,1), iip1*(jje-jjb+1), 0.0, 
      &                    champ_fft(1,j,1), iip1*(jje-jjb+1))
+#else
+                     champ_fft(:,j,:)=
+     &                    matmul(matrinvs(:,:,j-jfiltsu+1),
+     &                           champ_loc(:iim,j,:))
+#endif
                   ENDDO
                   
@@ -247,8 +268,14 @@
                   
                   DO j = jdfil,jffil
-                     CALL DGEMM("N", "N", iim, nbniv_loc, iim, 1.0, 
+#ifdef BLAS
+                     CALL SGEMM("N", "N", iim, nbniv_loc, iim, 1.0, 
      &                    matriceus(1,1,j-jfiltsu+1), iim, 
      &                    champ_loc(1,j,1), iip1*(jje-jjb+1), 0.0, 
      &                    champ_fft(1,j,1), iip1*(jje-jjb+1))
+#else
+                     champ_fft(:,j,:)=
+     &                    matmul(matriceus(:,:,j-jfiltsu+1),
+     &                           champ_loc(:iim,j,:))
+#endif
                   ENDDO
                   
@@ -256,8 +283,14 @@
                   
                   DO j = jdfil,jffil
-                     CALL DGEMM("N", "N", iim, nbniv_loc, iim, 1.0, 
+#ifdef BLAS
+                     CALL SGEMM("N", "N", iim, nbniv_loc, iim, 1.0, 
      &                    matricevs(1,1,j-jfiltsv+1), iim, 
      &                    champ_loc(1,j,1), iip1*(jje-jjb+1), 0.0, 
      &                    champ_fft(1,j,1), iip1*(jje-jjb+1))
+#else
+                     champ_fft(:,j,:)=
+     &                    matmul(matricevs(:,:,j-jfiltsv+1),
+     &                           champ_loc(:iim,j,:))
+#endif
                   ENDDO
                   
@@ -269,5 +302,5 @@
                
 c     !-------------------------------------!
-c     ! Dés-agregation des niveau verticaux !
+c     ! DÃ©s-agregation des niveau verticaux !
 c     ! uniquement necessaire pour une      !
 c     ! execution OpenMP                    !
@@ -402,2 +435,3 @@
       END SUBROUTINE filtreg_p
       END MODULE mod_filtreg_p
+
Index: LMDZ5/trunk/libf/filtrez/filtreg.F
===================================================================
--- LMDZ5/trunk/libf/filtrez/filtreg.F	(revision 1702)
+++ LMDZ5/trunk/libf/filtrez/filtreg.F	(revision 1705)
@@ -185,5 +185,5 @@
                DO j = jdfil,jffil
 #ifdef BLAS
-                  CALL DGEMM("N", "N", iim, nbniv, iim, 1.0, 
+                  CALL SGEMM("N", "N", iim, nbniv, iim, 1.0, 
      &                 matrinvn(1,1,j),
      &                 iim, champ(1,j,1), iip1*nlat, 0.0,
@@ -199,5 +199,5 @@
                DO j = jdfil,jffil
 #ifdef BLAS
-                  CALL DGEMM("N", "N", iim, nbniv, iim, 1.0, 
+                  CALL SGEMM("N", "N", iim, nbniv, iim, 1.0, 
      &                 matriceun(1,1,j),
      &                 iim, champ(1,j,1), iip1*nlat, 0.0,
@@ -213,5 +213,5 @@
                DO j = jdfil,jffil
 #ifdef BLAS
-                  CALL DGEMM("N", "N", iim, nbniv, iim, 1.0, 
+                  CALL SGEMM("N", "N", iim, nbniv, iim, 1.0, 
      &                 matricevn(1,1,j),
      &                 iim, champ(1,j,1), iip1*nlat, 0.0,
@@ -231,5 +231,5 @@
                DO j = jdfil,jffil
 #ifdef BLAS
-                  CALL DGEMM("N", "N", iim, nbniv, iim, 1.0, 
+                  CALL SGEMM("N", "N", iim, nbniv, iim, 1.0, 
      &                 matrinvs(1,1,j-jfiltsu+1),
      &                 iim, champ(1,j,1), iip1*nlat, 0.0,
@@ -247,5 +247,5 @@
                DO j = jdfil,jffil
 #ifdef BLAS
-                  CALL DGEMM("N", "N", iim, nbniv, iim, 1.0, 
+                  CALL SGEMM("N", "N", iim, nbniv, iim, 1.0, 
      &                 matriceus(1,1,j-jfiltsu+1),
      &                 iim, champ(1,j,1), iip1*nlat, 0.0,
@@ -262,5 +262,5 @@
                DO j = jdfil,jffil
 #ifdef BLAS
-                  CALL DGEMM("N", "N", iim, nbniv, iim, 1.0, 
+                  CALL SGEMM("N", "N", iim, nbniv, iim, 1.0, 
      &                 matricevs(1,1,j-jfiltsv+1),
      &                 iim, champ(1,j,1), iip1*nlat, 0.0,
Index: LMDZ5/trunk/libf/phylmd/printflag.F
===================================================================
--- LMDZ5/trunk/libf/phylmd/printflag.F	(revision 1702)
+++ LMDZ5/trunk/libf/phylmd/printflag.F	(revision 1705)
@@ -87,5 +87,5 @@
 !        radpas0  = NINT( 86400./tabcntr0(1)/INT( tabcntr0(6) ) )
         PRINT 100
-        PRINT 22, radpas0, radpas
+!        PRINT 22, radpas0, radpas
         PRINT 100
        ENDIF