Index: LMDZ5/trunk/libf/phylmd/physiq.F
===================================================================
--- LMDZ5/trunk/libf/phylmd/physiq.F	(revision 1764)
+++ LMDZ5/trunk/libf/phylmd/physiq.F	(revision 1779)
@@ -35,5 +35,6 @@
       use netcdf95, only: nf95_close
 cIM for NMC files
-      use netcdf, only: nf90_fill_real
+c     use netcdf, only: nf90_fill_real
+      use netcdf
       use mod_phys_lmdz_mpi_data, only: is_mpi_root
       USE aero_mod
@@ -50,50 +51,50 @@
       USE CFMIP_point_locations
       IMPLICIT none
-c======================================================================
-c
-c Auteur(s) Z.X. Li (LMD/CNRS) date: 19930818
-c
-c Objet: Moniteur general de la physique du modele
-cAA      Modifications quant aux traceurs :
-cAA                  -  uniformisation des parametrisations ds phytrac
-cAA                  -  stockage des moyennes des champs necessaires
-cAA                     en mode traceur off-line 
-c======================================================================
-c   CLEFS CPP POUR LES IO
-c   =====================
+!>======================================================================
+!!
+!! Auteur(s) Z.X. Li (LMD/CNRS) date: 19930818
+!!
+!! Objet: Moniteur general de la physique du modele
+!!AA      Modifications quant aux traceurs :
+!!AA                  -  uniformisation des parametrisations ds phytrac
+!!AA                  -  stockage des moyennes des champs necessaires
+!!AA                     en mode traceur off-line 
+!!======================================================================
+!!   CLEFS CPP POUR LES IO
+!!   =====================
 #define histNMC
 c#define histISCCP
-c======================================================================
-c    modif   ( P. Le Van ,  12/10/98 )
-c
-c  Arguments:
-c
-c nlon----input-I-nombre de points horizontaux
-c nlev----input-I-nombre de couches verticales, doit etre egale a klev
-c debut---input-L-variable logique indiquant le premier passage
-c lafin---input-L-variable logique indiquant le dernier passage
-c jD_cur       -R-jour courant a l'appel de la physique (jour julien)
-c jH_cur       -R-heure courante a l'appel de la physique (jour julien)
-c pdtphys-input-R-pas d'integration pour la physique (seconde)
-c paprs---input-R-pression pour chaque inter-couche (en Pa)
-c pplay---input-R-pression pour le mileu de chaque couche (en Pa)
-c pphi----input-R-geopotentiel de chaque couche (g z) (reference sol)
-c pphis---input-R-geopotentiel du sol
-c presnivs-input_R_pressions approximat. des milieux couches ( en PA)
-c u-------input-R-vitesse dans la direction X (de O a E) en m/s
-c v-------input-R-vitesse Y (de S a N) en m/s
-c t-------input-R-temperature (K)
-c qx------input-R-humidite specifique (kg/kg) et d'autres traceurs
-c d_t_dyn-input-R-tendance dynamique pour "t" (K/s)
-c d_q_dyn-input-R-tendance dynamique pour "q" (kg/kg/s)
-c flxmass_w -input-R- flux de masse verticale
-c d_u-----output-R-tendance physique de "u" (m/s/s)
-c d_v-----output-R-tendance physique de "v" (m/s/s)
-c d_t-----output-R-tendance physique de "t" (K/s)
-c d_qx----output-R-tendance physique de "qx" (kg/kg/s)
-c d_ps----output-R-tendance physique de la pression au sol
-cIM
-c PVteta--output-R-vorticite potentielle a des thetas constantes
-c======================================================================
+!!======================================================================
+!!    modif   ( P. Le Van ,  12/10/98 )
+!!
+!!  Arguments:
+!!
+!! nlon----input-I-nombre de points horizontaux
+!! nlev----input-I-nombre de couches verticales, doit etre egale a klev
+!! debut---input-L-variable logique indiquant le premier passage
+!! lafin---input-L-variable logique indiquant le dernier passage
+!! jD_cur       -R-jour courant a l'appel de la physique (jour julien)
+!! jH_cur       -R-heure courante a l'appel de la physique (jour julien)
+!! pdtphys-input-R-pas d'integration pour la physique (seconde)
+!! paprs---input-R-pression pour chaque inter-couche (en Pa)
+!! pplay---input-R-pression pour le mileu de chaque couche (en Pa)
+!! pphi----input-R-geopotentiel de chaque couche (g z) (reference sol)
+!! pphis---input-R-geopotentiel du sol
+!! presnivs-input_R_pressions approximat. des milieux couches ( en PA)
+!! u-------input-R-vitesse dans la direction X (de O a E) en m/s
+!! v-------input-R-vitesse Y (de S a N) en m/s
+!! t-------input-R-temperature (K)
+!! qx------input-R-humidite specifique (kg/kg) et d'autres traceurs
+!! d_t_dyn-input-R-tendance dynamique pour "t" (K/s)
+!! d_q_dyn-input-R-tendance dynamique pour "q" (kg/kg/s)
+!! flxmass_w -input-R- flux de masse verticale
+!! d_u-----output-R-tendance physique de "u" (m/s/s)
+!! d_v-----output-R-tendance physique de "v" (m/s/s)
+!! d_t-----output-R-tendance physique de "t" (K/s)
+!! d_qx----output-R-tendance physique de "qx" (kg/kg/s)
+!! d_ps----output-R-tendance physique de la pression au sol
+!!IM
+!! PVteta--output-R-vorticite potentielle a des thetas constantes
+!!======================================================================
 #include "dimensions.h"
       integer jjmp1
@@ -218,5 +219,9 @@
       REAL u(klon,klev)
       REAL v(klon,klev)
-      REAL t(klon,klev),theta(klon,klev)
+      REAL t(klon,klev),theta(klon,klev),thetal(klon,klev)
+c thetal: ligne suivante a decommenter si vous avez les fichiers     MPL 20130625
+c fth_fonctions.F90 et parkind1.F90
+c sinon thetal=theta
+c     REAL fth_thetae,fth_thetav,fth_thetal
       REAL qx(klon,klev,nqtot)
       REAL flxmass_w(klon,klev)
@@ -642,7 +647,7 @@
       REAL zw2(klon,klev+1)
       REAL fraca(klon,klev+1)        
-      REAL ztv(klon,klev) 
+      REAL ztv(klon,klev),ztva(klon,klev)
       REAL zpspsk(klon,klev)
-      REAL ztla(klon,klev) 
+      REAL ztla(klon,klev),zqla(klon,klev) 
       REAL zthl(klon,klev)
 
@@ -655,5 +660,5 @@
       real w0(klon)                                          ! Vitesse des thermiques au LCL
       real w_conv(klon)                                      ! Vitesse verticale de grande \'echelle au LCL
-      real tke0(klon,klev+1)                              ! TKE au début du pas de temps
+      real tke0(klon,klev+1)                                 ! TKE au début du pas de temps
       real therm_tke_max0(klon)                              ! TKE dans les thermiques au LCL 
       real env_tke_max0(klon)                                ! TKE dans l'environnement au LCL 
@@ -1057,5 +1062,5 @@
      .           prof2d_av = 3, prof3d_av = 4)
       character*30 nom_fichier
-      character*10 varname
+      character*40 varname
       character*40 vartitle
       character*20 varunits
@@ -2668,5 +2673,5 @@
      s      ,alp_bl_conv,alp_bl_stat
 ccc fin nrlmd le 10/04/2012
-     s                 )
+     s      ,zqla,ztva )
 
 ccc nrlmd le 10/04/2012
@@ -3451,4 +3456,12 @@
          solsw=0.
          radsol=0.
+         swup=0.    ! MPL 27102011 pour les fichiers AMMA_profiles et AMMA_scalars
+         swup0=0.
+         swdn=0.
+         swdn0=0.
+         lwup=0.
+         lwup0=0.
+         lwdn=0.
+         lwdn0=0.
       END IF
 
@@ -3963,4 +3976,10 @@
 cJYG/IM theta en fin de pas de temps de physique
         theta(i,k)=t_seri(i,k)*(100000./pplay(i,k))**(RD/RCPD)
+c thetal: 2 lignes suivantes a decommenter si vous avez les fichiers     MPL 20130625
+c fth_fonctions.F90 et parkind1.F90
+c sinon thetal=theta
+c       thetal(i,k)=fth_thetal(pplay(i,k),t_seri(i,k),q_seri(i,k),
+c    :         ql_seri(i,k))
+        thetal(i,k)=theta(i,k)
       ENDDO
       ENDDO